<template>
    <v-container fluid :fill-height="buildingsIsLoading || binsAreLoading">
      <!-- content loader -->
      <v-layout v-if="buildingsIsLoading || binsAreLoading" row wrap align-center justify-center>
        <loader></loader>
      </v-layout>
  
      <v-row v-else-if="canInsertTrash">
        <v-col cols="12">
          <v-card color="secondary darken-2" class="mx-3">
            <v-list-item>
              <v-list-item-avatar class="ml-n1">
                <v-icon large color="white">location_city</v-icon>
              </v-list-item-avatar>
              <v-list-item-content class="roboto white--text">
                <span>Welcome back home <strong>{{activeBuilding.name}}</strong></span>
              </v-list-item-content>
            </v-list-item>
          </v-card>
        </v-col>

        <v-divider></v-divider> 
          <v-col cols="12">
            <bins-board :bins="bins"></bins-board>
          </v-col>
          
          <v-divider></v-divider>
          <v-col cols="12">
            <trash-history></trash-history>
        </v-col>
        <photo/>
      </v-row>

      <!-- No building selected or available, show an empty view-->
      <empty-view v-else-if="!areAvailableBuildings" class="full-vh align-center" icon="location_city">
        <template slot="title">No active building</template>
        <template slot="message">Create new buildings and start recycling!</template>
        <template slot="actions">
          <v-btn color="primary" to="/buildings"> Manage buildings </v-btn>
        </template>
      </empty-view>
      
      <insert-trash-selection v-if="canInsertTrash"/>
    </v-container>
</template>

<style scoped>
.border-secondary {
  border-color: #8bc34a !important;
}
</style>

<script>
import BinsBoard from '@/components/bin/BinsBoard.vue'
import UserPhotoInsertion from '@/components/UserPhotoInsertion'
import InsertTrashSelection from '@/components/trash/InsertTrashSelection.vue'
import EmptyView from '@/components/EmptyView'
import ApiBin from "@/services/binsApi"
import Loader from '@/components/Loader'
import TrashHistoryVisualization from '@/components/visualization/TrashHistoryVisualization.vue'
import { createNamespacedHelpers } from 'vuex'
import { mapGetters, mapActions } from 'vuex'

export default {
  components: {
    'bins-board': BinsBoard,
    'loader': Loader,
    'photo' : UserPhotoInsertion,
    'insert-trash-selection' : InsertTrashSelection,
    'trash-history' : TrashHistoryVisualization,
    'empty-view': EmptyView
  },
  data: () => ({
    binsAreLoading: true
  }),
  computed: {
    ...mapGetters({
      buildingsIsLoading: "building/buildingsIsLoading",
      activeBuilding: "building/activeBuilding",
      buildings: "building/buildings",
      bins : "building/bins",
    }),
    canInsertTrash: function() {
      return this.areAvailableBuildings && this.activeBuilding && !this.binsAreLoading
    },
    areAvailableBuildings() {
      return !this.buildingsIsLoading && this.buildings.length > 0
    }
  },
  watch: {
    activeBuilding(val) {
      this.updateBins()
    }
  },
  mounted() {
    this.updateBins()
  },
  methods: {
    ...mapActions ({
      'checkImagePresence' : 'user/checkPicturePresence'
    }),
    updateBins() {
      this.binsAreLoading = true
      this.$store.dispatch("building/fetchBinsOfActiveBuilding")
        .catch(err => {})
        .finally(() => this.binsAreLoading = false)
    }
  }
};
</script>